Kea: isc::d2::D2Controller Class Reference

| Kea 1.5.0

Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
isc::d2::D2Controller Class Reference

Process Controller for D2 Process This class is the DHCP-DDNS specific derivation of DControllerBase. More...

`#include <d2_controller.h>`

Inheritance diagram for isc::d2::D2Controller:
[legend]

## Public Member Functions
virtual | ~D2Controller ()
| Destructor. More...
Public Member Functions inherited from isc::process::DControllerBase
| DControllerBase (const char *app_name, const char *bin_name)
| Constructor. More...
virtual | ~DControllerBase ()
| Destructor. More...
isc::data::ConstElementPtr | buildReportHandler (const std::string &command, isc::data::ConstElementPtr args)
| handler for 'build-report' command More...
virtual isc::data::ConstElementPtr | checkConfig (isc::data::ConstElementPtr new_config)
| Instance method invoked by the configuration event handler and which processes the actual configuration check. More...
virtual isc::data::ConstElementPtr | configFromFile ()
| Reconfigures the process from a configuration file. More...
isc::data::ConstElementPtr | configGetHandler (const std::string &command, isc::data::ConstElementPtr args)
| handler for config-get command More...
isc::data::ConstElementPtr | configTestHandler (const std::string &command, isc::data::ConstElementPtr args)
| handler for config-test command More...
isc::data::ConstElementPtr | configWriteHandler (const std::string &command, isc::data::ConstElementPtr args)
| handler for config-write command More...
std::string | getAppName () const
| Fetches the name of the application under control. More...
std::string | getBinName () const
| Fetches the name of the application executable. More...
std::string | getVersion (bool extended)
| returns Kea version on stdout and exit. More...
virtual void | launch (int argc, char *argv[], const bool test_mode)
| Acts as the primary entry point into the controller execution and provides the outermost application control logic: More...
isc::data::ConstElementPtr | shutdownHandler (const std::string &command, isc::data::ConstElementPtr args)
| handler for 'shutdown' command More...
virtual isc::data::ConstElementPtr | updateConfig (isc::data::ConstElementPtr new_config)
| Instance method invoked by the configuration event handler and which processes the actual configuration update. More...
isc::data::ConstElementPtr | versionGetHandler (const std::string &command, isc::data::ConstElementPtr args)
| handler for version-get command More...
Public Member Functions inherited from isc::process::Daemon
| Daemon ()
| Default constructor. More...
virtual | ~Daemon ()
| Destructor. More...
void | checkConfigFile () const
| Checks the configuration file name. More...
virtual void | cleanup ()
| Performs final deconfiguration. More...
void | createPIDFile (int pid=0)
| Creates the PID file. More...
std::string | getConfigFile () const
| Returns config file name. More...
std::string | getPIDFileDir () const
| Returns the directory used when forming default PID file name. More...
std::string | getPIDFileName () const
| Returns the current PID file name. More...
std::string | getProcName () const
| returns the process name This value is used as when forming the default PID file name More...
void | setConfigFile (const std::string &config_file)
| Sets the configuration file name. More...
void | setPIDFileDir (const std::string &pid_file_dir)
| Sets the PID file directory. More...
void | setPIDFileName (const std::string &pid_file_name)
| Sets PID file name. More...
void | setProcName (const std::string &proc_name)
| Sets the process name. More...
virtual void | shutdown ()
| Initiates shutdown procedure for the whole DHCPv6 server. More...
virtual size_t | writeConfigFile (const std::string &config_file, isc::data::ConstElementPtr cfg=isc::data::ConstElementPtr()) const
| Writes current configuration to specified file. More...

## Static Public Member Functions
static process::DControllerBasePtr & | instance ()
| Static singleton instance method. More...
Static Public Member Functions inherited from isc::process::Daemon
static void | configureLogger (const isc::data::ConstElementPtr &log_config, const isc::process::ConfigPtr &storage)
| Configures logger. More...
static std::string | getDefaultLoggerName ()
| Returns default logger name. More...
static bool | getVerbose ()
| Returns if running in verbose mode. More...
static std::string | getVersion (bool extended)
| returns Kea version on stdout and exits. More...
static void | loggerInit (const char *log_name, bool verbose)
| Initializes logger. More...
static void | setDefaultLoggerName (const std::string &logger)
| Sets the default logger name. More...
static void | setVerbose (const bool verbose)
| Sets or clears verbose mode. More...

## Static Public Attributes
static const char * | d2_app_name_ = "DhcpDdns"
| Defines the application name, this is passed into base class and appears in log statements. More...
static const char * | d2_bin_name_ = "kea-dhcp-ddns"
| Defines the executable name. More...

## Protected Member Functions
virtual std::string | getVersionAddendum ()
| Returns version info specific to D2. More...
Protected Member Functions inherited from isc::process::DControllerBase
void | checkConfigOnly ()
| Check the configuration. More...
virtual bool | customOption (int option, char *optarg)
| Virtual method that provides derivations the opportunity to support additional command line options. More...
virtual const std::string | getCustomOpts () const
| Virtual method which returns a string containing the option letters for any custom command line options supported by the derivation. More...
asiolink::IOServicePtr & | getIOService ()
| Getter for fetching the controller's IOService. More...
DProcessBasePtr | getProcess ()
| Fetches the current process. More...
virtual const std::string | getUsageText () const
| Virtual method which can be used to contribute derivation specific usage text. More...
void | initProcess ()
| Instantiates the application process and then initializes it. More...
void | initSignalHandling ()
| Initializes signal handling. More...
void | ioSignalHandler (IOSignalId sequence_id)
| Handler for processing IOSignals. More...
bool | isCheckOnly () const
| Supplies whether or not check only mode is enabled. More...
bool | isVerbose () const
| Supplies whether or not verbose logging is enabled. More...
bool | osSignalHandler (int signum)
| Handler for processing OS-level signals. More...
void | parseArgs (int argc, char *argv[])
| Processes the command line arguments. More...
virtual isc::data::ConstElementPtr | parseText (const std::string &input)
| Parse text into Elements. More...
virtual void | processSignal (int signum)
| Application-level signal processing method. More...
void | runProcess ()
| Invokes the application process's event loop,(DBaseProcess::run). More...
void | setCheckOnly (bool value)
| Method for enabling or disabling check only mode. More...
void | setVerbose (bool value)
| Method for enabling or disabling verbose logging. More...
isc::data::ConstElementPtr | shutdownProcess (isc::data::ConstElementPtr args)
| Initiates shutdown procedure. More...
void | usage (const std::string &text)
| Prints the program usage text to std error. More...
Protected Member Functions inherited from isc::process::Daemon
virtual void | handleSignal ()
| Invokes handler for the next received signal. More...
std::string | makePIDFileName () const
| Manufacture the pid file name. More...

## Additional Inherited Members
Static Protected Member Functions inherited from isc::process::DControllerBase
static DControllerBasePtr & | getController ()
| Static getter which returns the singleton instance. More...
static void | setController (const DControllerBasePtr &controller)
| Static setter which sets the singleton instance. More...
Protected Attributes inherited from isc::process::Daemon
isc::util::SignalHandler | signal_handler_
| Pointer to the common signal handler invoked by the handleSignal function. More...
isc::util::SignalSetPtr | signal_set_
| A pointer to the object installing custom signal handlers. More...

## Detailed Description

Process Controller for D2 Process This class is the DHCP-DDNS specific derivation of DControllerBase.

It creates and manages an instance of the DHCP-DDNS application process, D2Process.

Todo:
  Currently, this class provides only the minimum required specialized behavior to run the DHCP-DDNS service. It may very well expand as the service implementation evolves. Some thought was given to making DControllerBase a templated class but the labor savings versus the potential number of virtual methods which may be overridden didn't seem worth the clutter at this point.

Definition at line 25 of file d2_controller.h.

## Constructor & Destructor Documentation

## ◆ ~D2Controller()

isc::d2::D2Controller::~D2Controller | ( |  | ) |
| virtual

Destructor.

Definition at line 63 of file d2_controller.cc.

## Member Function Documentation

## ◆ getVersionAddendum()

std::string isc::d2::D2Controller::getVersionAddendum | ( |  | ) |
| protectedvirtual

Returns version info specific to D2.

Reimplemented from isc::process::DControllerBase.

Definition at line 67 of file d2_controller.cc.

References isc::cryptolink::CryptoLink::getVersion().

Here is the call graph for this function:

## ◆ instance()

DControllerBasePtr & isc::d2::D2Controller::instance | ( |  | ) |
| static

Static singleton instance method.

This method returns the base class singleton instance member. It instantiates the singleton and sets the base class instance member upon first invocation.

Returns
  returns the pointer reference to the singleton instance.

Definition at line 28 of file d2_controller.cc.

Referenced by main().

## Member Data Documentation

## ◆ d2_app_name_

const char * isc::d2::D2Controller::d2_app_name_ = "DhcpDdns"
| static

Defines the application name, this is passed into base class and appears in log statements.

Defines the application name, this is passed into base class it may be used to locate configuration data and appears in log statement.

Definition at line 39 of file d2_controller.h.

## ◆ d2_bin_name_

const char * isc::d2::D2Controller::d2_bin_name_ = "kea-dhcp-ddns"
| static

Defines the executable name.

Defines the executable name. This is passed into the base class.

This is passed into the base class by convention this should match the executable name.

Definition at line 43 of file d2_controller.h.

The documentation for this class was generated from the following files:

- d2_controller.h
- d2_controller.cc